'use strict';

var _entry = require('../entry');

var _entry2 = _interopRequireDefault(_entry);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _acorn = require('acorn');

var _escodegen = require('escodegen');

var _escodegen2 = _interopRequireDefault(_escodegen);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const parseCode = input => (0, _acorn.parse)(input, {
  ecmaVersion: 6,
  sourceType: 'module'
});


function readFile(filePath) {
  return _fs2.default.readFileSync(_path2.default.resolve(__dirname, filePath), { encoding: 'utf8' });
}

describe('inline CSS Loader', () => {
  const exportNodes = [];
  // exportNodes.push(require('./exportNode/es5'));
  // exportNodes.push(require('./exportNode/es6'));
  // exportNodes.push(require('./exportNode/babel'));
  // exportNodes.push(require('./exportNode/babelLoose'));
  // exportNodes.push(require('./exportNode/babelSpread'));
  // exportNodes.push(require('./exportNode/babelRuntimeSpread'));
  // exportNodes.push(require('./exportNode/webpack'));
  // exportNodes.push(require('./exportNode/webpack2'));
  // exportNodes.push(require('./exportNode/webpack3'));
  // exportNodes.push(require('./exportNode/webpack4'));
  exportNodes.push(readFile('exportNode/webpack5.txt'));
  it('should find nodes', () => {
    exportNodes.forEach(n => {
      const tree = parseCode(n);
      expect(tree).toBeDefined();
      const root = _entry2.default.getExportsNode(tree.body);
      expect(root).toBeDefined();
      expect(root.type).toEqual('ObjectExpression');
    });
  });

  // const fullparseCode = [];
  // fullparseCode.push(require('./fullObjects/simple').default);
  // fullparseCode.push(require('./fullObjects/spread').default);
  // fullparseCode.push(require('./fullObjects/media').default);
  // it('parseCode, doNothing', () => {
  //   fullparseCode.forEach(obj => {
  //     const generatedFromTree = escodegen.generate(parseCode(obj));
  //     expect(generatedFromTree).to.equal(inlineCssLoader.call({}, obj));
  //   });
  // });
  // //
  // it('temp', () => {
  //   const temp = require('./transforms/complex');
  //   const generatedFromTree = escodegen.generate(parseCode(temp.output));
  //   expect(generatedFromTree).to.equal(inlineCssLoader.call({}, temp.input));
  // });
  // //
  // const transforms = [];
  // transforms.push(require('./transforms/simple'));
  // transforms.push(require('./transforms/spread'));
  // transforms.push(require('./transforms/complex'));
  //
  // it('transforms', () => {
  //   transforms.forEach(t => {
  //     const generatedFromTree = escodegen.generate(parseCode(t.output));
  //     expect(generatedFromTree).to.equal(inlineCssLoader.call({}, t.input));
  //   });
  // });
  //
  // it('complexRealTransform', () => {
  //   const inp = require('./transforms/complexRealIn.txt');
  //   const out = require('./transforms/complexRealOut.txt');
  //   const generatedFromTree = escodegen.generate(parseCode(out));
  //   expect(generatedFromTree).to.equal(inlineCssLoader.call({}, inp));
  //   let inpES6 = require('./transforms/complexRealInES6.txt');
  //   let outES6 = require('./transforms/complexRealOutES6.txt');
  //   let generatedFromTreeES6 = escodegen.generate(parseCode(outES6));
  //   expect(generatedFromTreeES6).to.equal(inlineCssLoader.call({}, inpES6));
  //
  //   inpES6 = require('./transforms/complexFlowRealInES6.txt');
  //   outES6 = require('./transforms/complexFlowRealOutES6.txt');
  //   generatedFromTreeES6 = escodegen.generate(parseCode(outES6));
  //   expect(generatedFromTreeES6).to.equal(inlineCssLoader.call({}, inpES6));
  // });
  //
  // it('mediaQuery', () => {
  //   const inp = require('./transforms/mediaQueryIn.txt');
  //   const out = require('./transforms/mediaQueryOut.txt');
  //   const generatedFromTree = escodegen.generate(parseCode(out));
  //   expect(generatedFromTree).to.equal(inlineCssLoader.call({}, inp));
  // });
  //
  // const simple = [];
  // simple.push(require('./simple/simple'));
  // simple.push(require('./simple/simpleES6'));
  // simple.push(require('./simple/simpleOverride'));
  //
  // it('simple', () => {
  //   simple.forEach(t => {
  //     const generatedFromTree = escodegen.generate(parseCode(t.output));
  //     expect(generatedFromTree).to.equal(inlineCssLoader.call({}, t.input));
  //   });
  // });
  //
  // const big = [];
  //
  // it('big', () => {
  //   big.forEach(t => {
  //     const generatedFromTree = escodegen.generate(parseCode(t.output));
  //     expect(generatedFromTree).to.equal(inlineCssLoader.call({}, t.input));
  //   });
  // });
  //
  // it('webpack', () => {
  //   const inp = require('./webpackIn.txt');
  //   const out = require('./webpackOut.txt');
  //   const generatedFromTree = escodegen.generate(parseCode(out));
  //   expect(generatedFromTree).to.equal(inlineCssLoader.call({}, inp));
  // });
});